| Web Services for Remote Management 14.0 Reference documentation for web service interfaces to support remote management of Symantec Endpoint Protection

- Home
- Packages
- Classes

- Class List
- Class Hierarchy
- Class Members

List of all members | Classes | Public Member Functions
com.symantec.sepm.webservice.policy.PolicyService Interface Reference

The PolicyService API provides functionality for managing Symantec Endpoint Protection policies using an HTTPS SOAP request. More...

Inheritance diagram for com.symantec.sepm.webservice.policy.PolicyService:

## Classes
enum | PolicyType
| The policy types are used to specify the specific type of policy to import. More...

## Public Member Functions
PolicySummaryInfo | importPolicy (@WebParam(name="name") String name,@WebParam(name="groupId") String groupId,@WebParam(name="locationName") String locationName,@XmlMimeType("application/octet-stream") DataHandler dataHandler) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Imports the policy into the site's database and optionally assigns it to a group or to a location within a group. More...
PolicySummaryInfo | getPolicySummaryInfo (@WebParam(name="name") String name,@WebParam(name="type") String type) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Finds a policy that matches the name and the type supplied, and returns a PolicySummaryInfo object that represents the policy. More...
void | assignPolicy (@WebParam(name="policySummaryInfo") PolicySummaryInfo policySummaryInfo,@WebParam(name="groupId") String groupId,@WebParam(name="locationName") String locationName) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Assigns a policy to the specified group. More...
void | assignQuarantinePolicy (@WebParam(name="defaultHIPolicy") PolicySummaryInfo defaultHIPolicy,@WebParam(name="policy") PolicySummaryInfo policy,@WebParam(name="groupId") String groupId,@WebParam(name="locationName") String locationName,@WebParam(name="overridePolicy") boolean overridePolicy) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Assigns a policy to the specified group's quarantine location(s). More...

## Detailed Description

The PolicyService API provides functionality for managing Symantec Endpoint Protection policies using an HTTPS SOAP request.

This service lets you import a policy into a Symantec Endpoint Protection Manager site from another site. The policy must be exported from the first site by using the Symantec Endpoint Protection Manager console. It can then be imported into any other site by using a web service call. The policy can be assigned to specified groups or locations when it is imported, or it can be imported to the policy library and assigned to groups or locations at a later time.

This makes it simple to write an application that lets an administrator to define a custom policy and then assign the policy to all the sites that they manage. Administrators may need this functionality to help manage a large enterprise network or to manage sites for multiple customers (in the case of Managed Service Providers, or MSPs).

A call to the importPolicy or the assignPolicy method returns when the import or the assignment is written to the Symantec Endpoint Protection database. Assigning a policy, however, requires additional processing on both the server and the client.

The methods in this web service that deal with file transfers use Message Transmission Optimization Mechanism (MTOM) for fast efficient transfer of binary files. MTOM support is fully interoperable with .NET clients and servers. If you work with Metro, then your MTOM solution works out of the box as an endpoint or as a client. If your client uses the JAX-WS Reference Implementation, see http://metro.java.net/2.1.1/guide/Binary_Attachments__MTOM_.html for more information.

To access these endpoint web methods, the user must first log in to the management server with the appropriate administrator access rights and obtain a valid OAuth access token. For more information about obtaining and passing OAuth access tokens, see the Integration Guide.

## Member Function Documentation

PolicySummaryInfo com.symantec.sepm.webservice.policy.PolicyService.importPolicy | ( | @WebParam(name="name") String | name,
|  | @WebParam(name="groupId") String | groupId,
|  | @WebParam(name="locationName") String | locationName,
|  | @XmlMimeType("application/octet-stream") DataHandler | dataHandler
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Imports the policy into the site's database and optionally assigns it to a group or to a location within a group.

To import the policy, the administrator making the request must have access rights to manage the specific protection technology that is associated with the policy type to import. To apply the policy to a group, the administrator must also have access rights to manage the specified group. For more information about access rights, groups, and locations, see the Symantec Endpoint Protection documentation.

Parameters

  name | the unique name of the policy. If the name is already in use, an InvalidArgumentService exception is thrown.
  groupId | (optional) a group ID that identifies the Symantec Endpoint Protection group to assign the policy to. The group ID is obtained from ClientService#getGroupsByName.

This method supports only assignment to a single group. If group inheritance is turned off on the management server, then any child groups do not receive the policy. If group inheritance is turned on, then any child groups do inherit the policy.

If this parameter is null or an empty string, the policy is imported to the policy library, but it is not assigned to any group. The policy can be assigned to a group at a later time.

Parameters

  locationName | (optional) the case-insensitive name of the group location to which to assign the policy.

If this parameter is null or an empty string, the policy is assigned to the group. If the groupID parameter is null or an empty string, this parameter is ignored.

Parameters

  DataHandler | data-handler object through which attached file content can be retrieved. i.e. to retrieve the binary contents (policyFileContents) of an exported policy file.

The caller sets this field to the content ID of the MTOM file contents. MTOM then replaces the content ID place holder with the actual policy file bytes. The policy file bytes comprise the ZIP compressed policy file that was created when the policy was exported.

WARNING: Policy file names should not contain spaces. The MTOM content ID is derived from the file name, and the MTOM standard does not interpret a space as a character in a content ID.

Returns
  a PolicySummaryInfo object that uniquely identifies a policy in the policy library.

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method.
  InvalidArgumentServiceException | if the client supplied invalid parameters.
  ServiceException | if the web service encountered an error processing the web request.

PolicySummaryInfo com.symantec.sepm.webservice.policy.PolicyService.getPolicySummaryInfo | ( | @WebParam(name="name") String | name,
|  | @WebParam(name="type") String | type
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Finds a policy that matches the name and the type supplied, and returns a PolicySummaryInfo object that represents the policy.

The PolicySummaryInfo object can then be used in other calls, such as assignPolicy(PolicySummaryInfo, String, String)

Parameters

  name | the case-insensitive name of the policy in the Symantec Endpoint Protection Manager policy library. The policy name must be unique only within a given PolicyType. Policy name provided should be case-sensitive in the cases of multiple policy name that are with same name but differ in case.
  type | a String that identifies the policy type.

The string must be a case-insensitive match with one of the enumerated PolicyService.PolicyType names.

The web method parses the supplied type string back to the enumerated type. A string is used instead of an enumeration for portability.

Returns
  a PolicySummaryInfo object that uniquely identifies a policy within the policy library.

The PolicySummaryInfo object can be used in other calls that require a policy.

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method.
  InvalidArgumentServiceException | if the client supplied invalid parameters.
  ServiceException | if the web service encountered an error processing the web request.

void com.symantec.sepm.webservice.policy.PolicyService.assignPolicy | ( | @WebParam(name="policySummaryInfo") PolicySummaryInfo | policySummaryInfo,
|  | @WebParam(name="groupId") String | groupId,
|  | @WebParam(name="locationName") String | locationName
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Assigns a policy to the specified group.

The policy can be the locally installed default policy, a locally created custom policy, or an imported policy. The policy to assign must already exist in the policy library.

Overwrites any previously assigned policy with the new policy, regardless of whether there are differences between the policies. If you re-assign the same policy to a group, the web service call succeeds.

To assign the policy, the administrator making the request must have access rights to manage the specified group and the specific protection technology that is associated with the policy type to assign.

This call checks not just the access rights for the administrator making the request, but also the logged-in domain. A policy cannot be assigned to a group that belongs to a domain other than the domain that the current logged in administrator is logged into.

Parameters

  policySummaryInfo | a PolicySummaryInfo object that is obtained from the web method getPolicySummaryInfo(String, String).

Note: only the id and type attributes are required for the input PolicySummaryInfo object. All other attributes are ignored and not validated.

Parameters

  groupId | (required) a group ID obtained from ClientService#getGroupsByName that identifies the group which should be assigned the policy.

This method supports only assignment to a single group. If group inheritance is turned off on the management server, then child groups do not receive the policy. If group inheritance is turned on, then child groups do inherit the policy.

Parameters

  locationName | (optional) the case-insensitive name of the group location to which to assign the policy.

If this parameter is null or an empty string the policy is assigned to every location in the group.

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

void com.symantec.sepm.webservice.policy.PolicyService.assignQuarantinePolicy | ( | @WebParam(name="defaultHIPolicy") PolicySummaryInfo | defaultHIPolicy,
|  | @WebParam(name="policy") PolicySummaryInfo | policy,
|  | @WebParam(name="groupId") String | groupId,
|  | @WebParam(name="locationName") String | locationName,
|  | @WebParam(name="overridePolicy") boolean | overridePolicy
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Assigns a policy to the specified group's quarantine location(s).

The policy can be the locally installed default policy, a locally created custom policy, or an imported policy. The policy to assign must already exist in the policy library.

If the location does not have an assigned HI policy, it uses the defaultHIPolicy.

Parameters

  defaultHIPolicy | a Host Integrity Policy PolicySummaryInfo object that is obtained from the web method getPolicySummaryInfo(String, String).

If a Host Integrity Policy was not previously assigned to this location, this Host Integrity Policy is assigned as the default Host Integrity Policy.

Note: only the id and type attributes are required for the input PolicySummaryInfo object. All other attributes are ignored and not validated.

Parameters

  policy | a PolicySummaryInfo object that is obtained from the web method getPolicySummaryInfo(String, String) and assigned to the quarantine location.

Note: only the id and type attributes are required for the input PolicySummaryInfo object. All other attributes are ignored and not validated.

Parameters

  groupId | (required) a group ID obtained from ClientService#getGroupsByName that identifies the group to which the policy is assigned.

This method only supports the assignment to a single group. If group inheritance is turned off on the management server, then child groups do not receive the policy. If group inheritance is turned on, then child groups do inherit the policy.

Parameters

  locationName | (optional) the case-insensitive name of the group location to which to assign the policy.

If this parameter is null or an empty string, the policy is assigned to every location in the group.

Parameters

  overridePolicy | (required) if indicated as true, the policy overrides the previously assigned quarantine policy.

This parameter doesn't apply to defaultHIPolicy.

Exceptions

  InsufficientAccessServiceException | if the currently logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request